import pygame
import pygame.freetype
import sys
import random

pygame.init()
pygame.freetype.init()

window_info = pygame.display.Info()
window_width = window_info.current_w
window_height = window_info.current_h
window = pygame.display.set_mode((window_width, window_height), pygame.FULLSCREEN)
pygame.display.set_caption("Tic_Tac_Toe.V-7")

white = (255, 255, 255)
black = (0, 0, 0)

x_text = "x"
o_text = "o"
a_text = "a"
opponent_wins_text = "■ ■ ■ OPPONENT WINS ■ ■ ■"
opponent_O_wins_text = "■ ■ ■ OPPONENT 'o' WINS ■ ■ ■"
opponent_A_wins_text = "■ ■ ■ OPPONENT 'a' WINS ■ ■ ■"
player_2_wins_text = "■ ■ ■ PLAYER 2 WINS ■ ■ ■"
player_1_wins_text = "■ ■ ■ PLAYER 1 WINS ■ ■ ■"
you_win_text = "■ ■ ■ YOU WIN ■ ■ ■"
stalemate_text = "■ ■ ■ STALEMATE ■ ■ ■"

font_path_minecraftia = "Tic_Tac_Toe.Font.otf"
font_size = window_width / 10
font_minecraftia = pygame.freetype.Font(font_path_minecraftia, font_size)

rect_width = window_width / 4
rect_height = window_height / 4
rect_x = (window_width - rect_width) / 2
rect_y = (window_height - rect_height) / 2

close_width = window_width / 50
close_height = close_width
close_x = (window_width - close_width) - 10
close_y = 10

play_width = (window_width / 4) + (window_width / 32)
play_height = (window_height / 4)
play_x = (window_width / 2) - (play_width / 2)
play_y = (window_height / 2) - (play_height / 2)

play_three_mode_width = play_width
play_three_mode_height = play_height
play_three_mode_x = play_x
play_three_mode_y = (play_y - play_height) - 10

play_local_mode_width = play_width
play_local_mode_height = play_height
play_local_mode_x = play_x
play_local_mode_y = (play_y + play_height) + 10

Space_BG_width_GS1 = (window_width / 3) + (window_width / 8)
Space_BG_height_GS1 = Space_BG_width_GS1
Space_BG_x_GS1 = (window_width / 2) - (Space_BG_width_GS1 / 2)
Space_BG_y_GS1 = (window_height / 2) - (Space_BG_height_GS1 / 2)

Space_1_width_GS1 = (Space_BG_width_GS1 - 50) / 4
Space_1_height_GS1 = (Space_BG_height_GS1 - 50) / 4
Space_1_x_GS1 = Space_BG_x_GS1 + 10
Space_1_y_GS1 = Space_BG_y_GS1 + 10

Space_2_width_GS1 = Space_1_width_GS1
Space_2_height_GS1 = Space_1_height_GS1
Space_2_x_GS1 = (Space_1_x_GS1 + Space_2_width_GS1) + 10
Space_2_y_GS1 = Space_1_y_GS1

Space_3_width_GS1 = Space_1_width_GS1
Space_3_height_GS1 = Space_1_height_GS1
Space_3_x_GS1 = (Space_2_x_GS1 + Space_3_width_GS1) + 10
Space_3_y_GS1 = Space_1_y_GS1

Space_4_width_GS1 = Space_1_width_GS1
Space_4_height_GS1 = Space_1_height_GS1
Space_4_x_GS1 = (Space_3_x_GS1 + Space_4_width_GS1) + 10
Space_4_y_GS1 = Space_1_y_GS1

Space_5_width_GS1 = Space_1_width_GS1
Space_5_height_GS1 = Space_1_height_GS1
Space_5_x_GS1 = Space_1_x_GS1
Space_5_y_GS1 = (Space_1_y_GS1 + Space_5_height_GS1) + 10

Space_6_width_GS1 = Space_1_width_GS1
Space_6_height_GS1 = Space_1_height_GS1
Space_6_x_GS1 = Space_2_x_GS1
Space_6_y_GS1 = Space_5_y_GS1

Space_7_width_GS1 = Space_1_width_GS1
Space_7_height_GS1 = Space_1_height_GS1
Space_7_x_GS1 = Space_3_x_GS1
Space_7_y_GS1 = Space_5_y_GS1

Space_8_width_GS1 = Space_1_width_GS1
Space_8_height_GS1 = Space_1_height_GS1
Space_8_x_GS1 = Space_4_x_GS1
Space_8_y_GS1 = Space_5_y_GS1

Space_9_width_GS1 = Space_1_width_GS1
Space_9_height_GS1 = Space_1_height_GS1
Space_9_x_GS1 = Space_1_x_GS1
Space_9_y_GS1 = (Space_5_y_GS1 + Space_9_height_GS1) + 10

Space_10_width_GS1 = Space_1_width_GS1
Space_10_height_GS1 = Space_1_height_GS1
Space_10_x_GS1 = Space_2_x_GS1
Space_10_y_GS1 = Space_9_y_GS1

Space_11_width_GS1 = Space_1_width_GS1
Space_11_height_GS1 = Space_1_height_GS1
Space_11_x_GS1 = Space_3_x_GS1
Space_11_y_GS1 = Space_9_y_GS1

Space_12_width_GS1 = Space_1_width_GS1
Space_12_height_GS1 = Space_1_height_GS1
Space_12_x_GS1 = Space_4_x_GS1
Space_12_y_GS1 = Space_9_y_GS1

Space_13_width_GS1 = Space_1_width_GS1
Space_13_height_GS1 = Space_1_height_GS1
Space_13_x_GS1 = Space_1_x_GS1
Space_13_y_GS1 = (Space_9_y_GS1 + Space_13_height_GS1) + 10

Space_14_width_GS1 = Space_1_width_GS1
Space_14_height_GS1 = Space_1_height_GS1
Space_14_x_GS1 = Space_2_x_GS1
Space_14_y_GS1 = Space_13_y_GS1

Space_15_width_GS1 = Space_1_width_GS1
Space_15_height_GS1 = Space_1_height_GS1
Space_15_x_GS1 = Space_3_x_GS1
Space_15_y_GS1 = Space_13_y_GS1

Space_16_width_GS1 = Space_1_width_GS1
Space_16_height_GS1 = Space_1_height_GS1
Space_16_x_GS1 = Space_4_x_GS1
Space_16_y_GS1 = Space_13_y_GS1

Space_BG_width = (window_width / 3) + (window_width / 8)
Space_BG_height = Space_BG_width
Space_BG_x = (window_width / 2) - (Space_BG_width / 2)
Space_BG_y = (window_height / 2) - (Space_BG_height / 2)

Space_1_width = (Space_BG_width - 40) / 3
Space_1_height = (Space_BG_height - 40) / 3
Space_1_x = Space_BG_x + 10
Space_1_y = Space_BG_y + 10

Space_2_width = Space_1_width
Space_2_height = Space_1_height
Space_2_x = (Space_1_x + Space_2_width) + 10
Space_2_y = Space_1_y

Space_3_width = Space_1_width
Space_3_height = Space_1_height
Space_3_x = (Space_2_x + Space_3_width) + 10
Space_3_y = Space_1_y

Space_4_width = Space_1_width
Space_4_height = Space_1_height
Space_4_x = Space_1_x
Space_4_y = (Space_1_y + Space_4_height) + 10

Space_5_width = Space_1_width
Space_5_height = Space_1_height
Space_5_x = Space_2_x
Space_5_y = Space_4_y

Space_6_width = Space_1_width
Space_6_height = Space_1_height
Space_6_x = Space_3_x
Space_6_y = Space_4_y

Space_7_width = Space_1_width
Space_7_height = Space_1_height
Space_7_x = Space_1_x
Space_7_y = (Space_4_y + Space_7_height) + 10

Space_8_width = Space_1_width
Space_8_height = Space_1_height
Space_8_x = Space_2_x
Space_8_y = Space_7_y

Space_9_width = Space_1_width
Space_9_height = Space_1_height
Space_9_x = Space_3_x
Space_9_y = Space_7_y

Available_list_GS1 = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9", "space_10", "space_11", "space_12", "space_13", "space_14", "space_15", "space_16"]
space_1_GS1 = 0
space_2_GS1 = 0
space_3_GS1 = 0
space_4_GS1 = 0
space_5_GS1 = 0
space_6_GS1 = 0
space_7_GS1 = 0
space_8_GS1 = 0
space_9_GS1 = 0
space_10_GS1 = 0
space_11_GS1 = 0
space_12_GS1 = 0
space_13_GS1 = 0
space_14_GS1 = 0
space_15_GS1 = 0
space_16_GS1 = 0

Available_list = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9"]
space_1 = 0
space_2 = 0
space_3 = 0
space_4 = 0
space_5 = 0
space_6 = 0
space_7 = 0
space_8 = 0
space_9 = 0

def Close_Button():
    close_button = pygame.image.load("Close_button.png")
    if close_width != 50:
        close_button = pygame.transform.scale(close_button, (close_width, close_height))
    window.blit(close_button, (close_x, close_y))
    pygame.display.update()

def Main_menu():
    window.fill(white)
    Close_Button()
    play_button = pygame.image.load("Play.Classic.png")
    if play_width != 400 and play_height != 200:
        play_button = pygame.transform.scale(play_button, (play_width, play_height))
    window.blit(play_button, (play_x, play_y))
    play_three_mode_button = pygame.image.load("Play.3_Player.png")
    if play_three_mode_width != 400 and play_three_mode_height != 200:
        play_three_mode_button = pygame.transform.scale(play_three_mode_button, (play_three_mode_width, play_three_mode_height))
    window.blit(play_three_mode_button, (play_three_mode_x, play_three_mode_y))
    play_local_mode_button = pygame.image.load("Play.Local_PVP.png")
    if play_local_mode_width != 400 and play_local_mode_height != 200:
        play_local_mode_button = pygame.transform.scale(play_local_mode_button, (play_local_mode_width, play_local_mode_height))
    window.blit(play_local_mode_button, (play_local_mode_x, play_local_mode_y))
    pygame.display.update()

def Player_Won():
    Close_Button()
    pygame.time.wait(1000)
    window.fill(white)
    if game_state == 1 or game_state == 2:
        text_width, text_height = font_minecraftia.get_rect(you_win_text)[2:]
        text_x = rect_x + (rect_width - text_width) // 2
        text_y = rect_y + (rect_height - text_height) // 2
        text_surface, _ = font_minecraftia.render(you_win_text, black)
        window.blit(text_surface, (text_x, text_y))
        pygame.display.update()
    elif game_state == 3:
        if player_turn == 1:
            text_width, text_height = font_minecraftia.get_rect(player_2_wins_text)[2:]
            text_x = rect_x + (rect_width - text_width) // 2
            text_y = rect_y + (rect_height - text_height) // 2
            text_surface, _ = font_minecraftia.render(player_2_wins_text, black)
            window.blit(text_surface, (text_x, text_y))
            pygame.display.update()
        if player_turn == 2:
            text_width, text_height = font_minecraftia.get_rect(player_1_wins_text)[2:]
            text_x = rect_x + (rect_width - text_width) // 2
            text_y = rect_y + (rect_height - text_height) // 2
            text_surface, _ = font_minecraftia.render(player_1_wins_text, black)
            window.blit(text_surface, (text_x, text_y))
            pygame.display.update()
    pygame.time.wait(1500)
    restart_game()

def stalemate():
    Close_Button()
    window.fill(white)
    pygame.time.wait(1000)
    text_surface, _ = font_minecraftia.render(stalemate_text, black)
    text_x = (window_width - text_surface.get_width()) // 2
    text_y = (window_height - text_surface.get_height()) // 2
    window.blit(text_surface, (text_x, text_y))
    pygame.display.update()
    pygame.time.wait(1500)
    restart_game()

def restart_game():
    global space_1_GS1, space_2_GS1, space_3_GS1, space_4_GS1, space_5_GS1, space_6_GS1, space_7_GS1, space_8_GS1, space_9_GS1, space_10_GS1, space_11_GS1, space_12_GS1, space_13_GS1, space_14_GS1, space_15_GS1, space_16_GS1, space_1, space_2, space_3, space_4, space_5, space_6, space_7, space_8, space_9, Available_list, Available_list_GS1, opponent_turn, player_turn
    opponent_turn = False
    player_turn = 1
    space_1_GS1 = 0
    space_2_GS1 = 0
    space_3_GS1 = 0
    space_4_GS1 = 0
    space_5_GS1 = 0
    space_6_GS1 = 0
    space_7_GS1 = 0
    space_8_GS1 = 0
    space_9_GS1 = 0
    space_10_GS1 = 0
    space_11_GS1 = 0
    space_12_GS1 = 0
    space_13_GS1 = 0
    space_14_GS1 = 0
    space_15_GS1 = 0
    space_16_GS1 = 0
    space_1 = 0
    space_2 = 0
    space_3 = 0
    space_4 = 0
    space_5 = 0
    space_6 = 0
    space_7 = 0
    space_8 = 0
    space_9 = 0
    Available_list_GS1 = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9", "space_10", "space_11", "space_12", "space_13", "space_14", "space_15", "space_16"]
    Available_list = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9"]
    playing_board()

def opponent_O_wins():
    Close_Button()
    pygame.time.wait(1000)
    window.fill((255, 255, 255))
    text_surface, _ = font_minecraftia.render(opponent_O_wins_text, black)
    text_x = (window_width - text_surface.get_width()) // 2
    text_y = (window_height - text_surface.get_height()) // 2
    window.blit(text_surface, (text_x, text_y))
    pygame.display.update()
    pygame.time.wait(1500)
    restart_game()

def opponent_A_wins():
    Close_Button()
    pygame.time.wait(1000)
    window.fill(white)
    text_surface, _ = font_minecraftia.render(opponent_A_wins_text, black)
    text_x = (window_width - text_surface.get_width()) // 2
    text_y = (window_height - text_surface.get_height()) // 2
    window.blit(text_surface, (text_x, text_y))
    pygame.display.update()
    pygame.time.wait(1500)
    restart_game()

def Opponent_wins():
    Close_Button()
    pygame.time.wait(1000)
    window.fill(white)
    if game_state == 2:
        text_surface, _ = font_minecraftia.render(opponent_wins_text, black)
        text_x = (window_width - text_surface.get_width()) // 2
        text_y = (window_height - text_surface.get_height()) // 2
        window.blit(text_surface, (text_x, text_y))
        pygame.display.update()
    if game_state == 3:
        Player_Won()
    pygame.time.wait(1500)
    restart_game()

def opponent_A_moves():
    global space_1_GS1, space_2_GS1, space_3_GS1, space_4_GS1, space_5_GS1, space_6_GS1, space_7_GS1, space_8_GS1, space_9_GS1, space_10_GS1, space_11_GS1, space_12_GS1, space_13_GS1, space_14_GS1, space_15_GS1, space_16_GS1, Available_list_GS1
    opponent_choice_2 = random.choice(Available_list_GS1)
    if opponent_choice_2 == "space_1":
        Available_list_GS1.remove("space_1")
        space_1_GS1 = 3
    if opponent_choice_2 == "space_2":
        Available_list_GS1.remove("space_2")
        space_2_GS1 = 3
    if opponent_choice_2 == "space_3":
        Available_list_GS1.remove("space_3")
        space_3_GS1 = 3
    if opponent_choice_2 == "space_4":            
        Available_list_GS1.remove("space_4")
        space_4_GS1 = 3
    if opponent_choice_2 == "space_5":
        Available_list_GS1.remove("space_5")
        space_5_GS1 = 3
    if opponent_choice_2 == "space_6":            
        Available_list_GS1.remove("space_6")
        space_6_GS1 = 3
    if opponent_choice_2 == "space_7":
        Available_list_GS1.remove("space_7")
        space_7_GS1 = 3
    if opponent_choice_2 == "space_8":
        Available_list_GS1.remove("space_8")
        space_8_GS1 = 3
    if opponent_choice_2 == "space_9":
        Available_list_GS1.remove("space_9")
        space_9_GS1 = 3
    if opponent_choice_2 == "space_10":
        Available_list_GS1.remove("space_10")
        space_10_GS1 = 3
    if opponent_choice_2 == "space_11":
        Available_list_GS1.remove("space_11")
        Space_11_GS1 = 3
    if opponent_choice_2 == "space_12":
        Available_list_GS1.remove("space_12")
        space_12_GS1 = 3
    if opponent_choice_2 == "space_13":
        Available_list_GS1.remove("space_13")
        space_13_GS1 = 3
    if opponent_choice_2 == "space_14":
        Available_list_GS1.remove("space_14")
        space_14_GS1 = 3
    if opponent_choice_2 == "space_15":
        Available_list_GS1.remove("space_15")
        space_15_GS1 = 3
    if opponent_choice_2 == "space_16":
        Available_list_GS1.remove("space_16")
        space_16_GS1 = 3
    playing_board()

def opponent_O_moves():
    global space_1_GS1, space_2_GS1, space_3_GS1, space_4_GS1, space_5_GS1, space_6_GS1, space_7_GS1, space_8_GS1, space_9_GS1, space_10_GS1, space_11_GS1, space_12_GS1, space_13_GS1, space_14_GS1, space_15_GS1, space_16_GS1, Available_list
    pygame.time.wait(500)
    opponent_choice_1 = random.choice(Available_list_GS1)
    if opponent_turn == True:
        if opponent_choice_1 == "space_1":
            Available_list_GS1.remove("space_1")
            space_1_GS1 = 2
        if opponent_choice_1 == "space_2":
            Available_list_GS1.remove("space_2")
            space_2_GS1 = 2
        if opponent_choice_1 == "space_3":
            Available_list_GS1.remove("space_3")
            space_3_GS1 = 2
        if opponent_choice_1 == "space_4":
            Available_list_GS1.remove("space_4")
            space_4_GS1 = 2
        if opponent_choice_1 == "space_5":
            Available_list_GS1.remove("space_5")
            space_5_GS1 = 2
        if opponent_choice_1 == "space_6":
            Available_list_GS1.remove("space_6")
            space_6_GS1 = 2
        if opponent_choice_1 == "space_7":
            Available_list_GS1.remove("space_7")
            space_7_GS1 = 2
        if opponent_choice_1 == "space_8":
            Available_list_GS1.remove("space_8")
            space_8_GS1 = 2
        if opponent_choice_1 == "space_9":
            Available_list_GS1.remove("space_9")
            space_9_GS1 = 2
        if opponent_choice_1 == "space_10":
            Available_list_GS1.remove("space_10")
            space_10_GS1 = 2
        if opponent_choice_1 == "space_11":
            Available_list_GS1.remove("space_11")
            space_11_GS1 = 2
        if opponent_choice_1 == "space_12":
            Available_list_GS1.remove("space_12")
            space_12_GS1 = 2
        if opponent_choice_1 == "space_13":
            Available_list_GS1.remove("space_13")
            space_13_GS1 = 2
        if opponent_choice_1 == "space_14":
            Available_list_GS1.remove("space_14")
            space_14_GS1 = 2
        if opponent_choice_1 == "space_15":
            Available_list_GS1.remove("space_15")
            space_15_GS1 = 2
        if opponent_choice_1 == "space_16":
            Available_list_GS1.remove("space_16")
            space_16_GS1 = 2
        playing_board()
        pygame.time.wait(500)
        opponent_A_moves()

def Opponent_move():
    global space_1, space_2, space_3, space_4, space_5, space_6, space_7, space_8, space_9, opponent_turn
    pygame.time.wait(500)
    opponent_choice = random.choice(Available_list)
    if opponent_turn == True:
        if opponent_choice == "space_1":
            Available_list.remove("space_1")
            space_1 = 2
            opponent_turn = False
        if opponent_choice == "space_2":
            Available_list.remove("space_2")
            space_2 = 2
            opponent_turn = False
        if opponent_choice == "space_3":
            Available_list.remove("space_3")
            space_3 = 2
            opponent_turn = False
        if opponent_choice == "space_4":
            Available_list.remove("space_4")
            space_4 = 2
            opponent_turn = False
        if opponent_choice == "space_5":
            Available_list.remove("space_5")
            space_5 = 2
            opponent_turn = False
        if opponent_choice == "space_6":
            Available_list.remove("space_6")
            space_6 = 2
            opponent_turn = False
        if opponent_choice == "space_7":
            Available_list.remove("space_7")
            space_7 = 2
            opponent_turn = False
        if opponent_choice == "space_8":
            Available_list.remove("space_8")
            space_8 = 2
            opponent_turn = False
        if opponent_choice == "space_9":
            Available_list.remove("space_9")
            space_9 = 2
            opponent_turn = False
        playing_board()

def Draw_text(space_x, space_y, space_width, space_height, text):
    if game_state == 1:
        if text == a_text:
            text_surface, _ = font_minecraftia.render(text, black)
            text_x = (space_x + ((space_width / 2) - (font_size / 2))) + window_height / 50
            text_y = ((space_y + ((space_height / 2) - (font_size / 2))) + window_height / 50) + (font_size / 4)
            window.blit(text_surface, (text_x, text_y))
        elif text == o_text:
            text_surface, _ = font_minecraftia.render(text, black)
            text_x = ((space_x + ((space_width / 2) - (font_size / 2))) + window_height / 50) + (font_size / 24)
            text_y = ((space_y + ((space_height / 2) - (font_size / 2))) + window_height / 50) + (font_size / 24)
            window.blit(text_surface, (text_x, text_y))
        elif text == x_text:
            text_surface, _ = font_minecraftia.render(text, black)
            text_x = (space_x + ((space_width / 2) - (font_size / 2))) + window_height / 50
            text_y = (space_y + ((space_height / 2) - (font_size / 2))) + window_height / 50
            window.blit(text_surface, (text_x, text_y))
    elif game_state == 2 or game_state == 3:
        text_surface, _ = font_minecraftia.render(text, black)
        text_x = (space_x + ((space_width / 2) - (font_size / 2))) + window_height / 50
        text_y = (space_y + ((space_height / 2) - (font_size / 2))) + window_height / 50
        window.blit(text_surface, (text_x, text_y))

def Handle_text():
    Close_Button()
    global space_1_GS1, space_2_GS1, space_3_GS1, space_4_GS1, space_5_GS1, space_6_GS1, space_7_GS1, space_8_GS1, space_9_GS1, space_10_GS1, space_11_GS1, space_12_GS1, space_13_GS1, space_14_GS1, space_15_GS1, space_16_GS1
    
    if game_state == 1:
        if space_1_GS1 == 1:
            Draw_text(Space_1_x_GS1, Space_1_y_GS1, Space_1_width_GS1, Space_1_height_GS1, x_text)
        if space_2_GS1 == 1:
            Draw_text(Space_2_x_GS1, Space_2_y_GS1, Space_2_width_GS1, Space_2_height_GS1, x_text)
        if space_3_GS1 == 1:
            Draw_text(Space_3_x_GS1, Space_3_y_GS1, Space_3_width_GS1, Space_3_height_GS1, x_text)
        if space_4_GS1 == 1:
            Draw_text(Space_4_x_GS1, Space_4_y_GS1, Space_4_width_GS1, Space_4_height_GS1, x_text)
        if space_5_GS1 == 1:
            Draw_text(Space_5_x_GS1, Space_5_y_GS1, Space_5_width_GS1, Space_5_height_GS1, x_text)
        if space_6_GS1 == 1:
            Draw_text(Space_6_x_GS1, Space_6_y_GS1, Space_6_width_GS1, Space_6_height_GS1, x_text)
        if space_7_GS1 == 1:
            Draw_text(Space_7_x_GS1, Space_7_y_GS1, Space_7_width_GS1, Space_7_height_GS1, x_text)
        if space_8_GS1 == 1:
            Draw_text(Space_8_x_GS1, Space_8_y_GS1, Space_8_width_GS1, Space_8_height_GS1, x_text)
        if space_9_GS1 == 1:
            Draw_text(Space_9_x_GS1, Space_9_y_GS1, Space_9_width_GS1, Space_9_height_GS1, x_text)
        if space_10_GS1 == 1:
            Draw_text(Space_10_x_GS1, Space_10_y_GS1, Space_10_width_GS1, Space_10_height_GS1, x_text)
        if space_11_GS1 == 1:
            Draw_text(Space_11_x_GS1, Space_11_y_GS1, Space_11_width_GS1, Space_11_height_GS1, x_text)
        if space_12_GS1 == 1:
            Draw_text(Space_12_x_GS1, Space_12_y_GS1, Space_12_width_GS1, Space_12_height_GS1, x_text)
        if space_13_GS1 == 1:
            Draw_text(Space_13_x_GS1, Space_13_y_GS1, Space_13_width_GS1, Space_13_height_GS1, x_text)
        if space_14_GS1 == 1:
            Draw_text(Space_14_x_GS1, Space_14_y_GS1, Space_14_width_GS1, Space_14_height_GS1, x_text)
        if space_15_GS1 == 1:
            Draw_text(Space_15_x_GS1, Space_15_y_GS1, Space_15_width_GS1, Space_15_height_GS1, x_text)
        if space_16_GS1 == 1:
            Draw_text(Space_16_x_GS1, Space_16_y_GS1, Space_16_width_GS1, Space_16_height_GS1, x_text)
        if space_1_GS1 == 2:
            Draw_text(Space_1_x_GS1, Space_1_y_GS1, Space_1_width_GS1, Space_1_height_GS1, o_text)
        if space_2_GS1 == 2:
            Draw_text(Space_2_x_GS1, Space_2_y_GS1, Space_2_width_GS1, Space_2_height_GS1, o_text)
        if space_3_GS1 == 2:
            Draw_text(Space_3_x_GS1, Space_3_y_GS1, Space_3_width_GS1, Space_3_height_GS1, o_text)
        if space_4_GS1 == 2:
            Draw_text(Space_4_x_GS1, Space_4_y_GS1, Space_4_width_GS1, Space_4_height_GS1, o_text)
        if space_5_GS1 == 2:
            Draw_text(Space_5_x_GS1, Space_5_y_GS1, Space_5_width_GS1, Space_5_height_GS1, o_text)
        if space_6_GS1 == 2:
            Draw_text(Space_6_x_GS1, Space_6_y_GS1, Space_6_width_GS1, Space_6_height_GS1, o_text)
        if space_7_GS1 == 2:
            Draw_text(Space_7_x_GS1, Space_7_y_GS1, Space_7_width_GS1, Space_7_height_GS1, o_text)
        if space_8_GS1 == 2:
            Draw_text(Space_8_x_GS1, Space_8_y_GS1, Space_8_width_GS1, Space_8_height_GS1, o_text)
        if space_9_GS1 == 2:
            Draw_text(Space_9_x_GS1, Space_9_y_GS1, Space_9_width_GS1, Space_9_height_GS1, o_text)
        if space_10_GS1 == 2:
            Draw_text(Space_10_x_GS1, Space_10_y_GS1, Space_10_width_GS1, Space_10_height_GS1, o_text)
        if space_11_GS1 == 2:
            Draw_text(Space_11_x_GS1, Space_11_y_GS1, Space_11_width_GS1, Space_11_height_GS1, o_text)
        if space_12_GS1 == 2:
            Draw_text(Space_12_x_GS1, Space_12_y_GS1, Space_12_width_GS1, Space_12_height_GS1, o_text)
        if space_13_GS1 == 2:
            Draw_text(Space_13_x_GS1, Space_13_y_GS1, Space_13_width_GS1, Space_13_height_GS1, o_text)
        if space_14_GS1 == 2:
            Draw_text(Space_14_x_GS1, Space_14_y_GS1, Space_14_width_GS1, Space_14_height_GS1, o_text)
        if space_15_GS1 == 2:
            Draw_text(Space_15_x_GS1, Space_15_y_GS1, Space_15_width_GS1, Space_15_height_GS1, o_text)
        if space_16_GS1 == 2:
            Draw_text(Space_16_x_GS1, Space_16_y_GS1, Space_16_width_GS1, Space_16_height_GS1, o_text)
        if space_1_GS1 == 3:
            Draw_text(Space_1_x_GS1, Space_1_y_GS1, Space_1_width_GS1, Space_1_height_GS1, a_text)
        if space_2_GS1 == 3:
            Draw_text(Space_2_x_GS1, Space_2_y_GS1, Space_2_width_GS1, Space_2_height_GS1, a_text)
        if space_3_GS1 == 3:
            Draw_text(Space_3_x_GS1, Space_3_y_GS1, Space_3_width_GS1, Space_3_height_GS1, a_text)
        if space_4_GS1 == 3:
            Draw_text(Space_4_x_GS1, Space_4_y_GS1, Space_4_width_GS1, Space_4_height_GS1, a_text)
        if space_5_GS1 == 3:
            Draw_text(Space_5_x_GS1, Space_5_y_GS1, Space_5_width_GS1, Space_5_height_GS1, a_text)
        if space_6_GS1 == 3:
            Draw_text(Space_6_x_GS1, Space_6_y_GS1, Space_6_width_GS1, Space_6_height_GS1, a_text)
        if space_7_GS1 == 3:
            Draw_text(Space_7_x_GS1, Space_7_y_GS1, Space_7_width_GS1, Space_7_height_GS1, a_text)
        if space_8_GS1 == 3:
            Draw_text(Space_8_x_GS1, Space_8_y_GS1, Space_8_width_GS1, Space_8_height_GS1, a_text)
        if space_9_GS1 == 3:
            Draw_text(Space_9_x_GS1, Space_9_y_GS1, Space_9_width_GS1, Space_9_height_GS1, a_text)
        if space_10_GS1 == 3:
            Draw_text(Space_10_x_GS1, Space_10_y_GS1, Space_10_width_GS1, Space_10_height_GS1, a_text)
        if space_11_GS1 == 3:
            Draw_text(Space_11_x_GS1, Space_11_y_GS1, Space_11_width_GS1, Space_11_height_GS1, a_text)
        if space_12_GS1 == 3:
            Draw_text(Space_12_x_GS1, Space_12_y_GS1, Space_12_width_GS1, Space_12_height_GS1, a_text)
        if space_13_GS1 == 3:
            Draw_text(Space_13_x_GS1, Space_13_y_GS1, Space_13_width_GS1, Space_13_height_GS1, a_text)
        if space_14_GS1 == 3:
            Draw_text(Space_14_x_GS1, Space_14_y_GS1, Space_14_width_GS1, Space_14_height_GS1, a_text)
        if space_15_GS1 == 3:
            Draw_text(Space_15_x_GS1, Space_15_y_GS1, Space_15_width_GS1, Space_15_height_GS1, a_text)
        if space_16_GS1 == 3:
            Draw_text(Space_16_x_GS1, Space_16_y_GS1, Space_16_width_GS1, Space_16_height_GS1, a_text)
    elif game_state == 2 or game_state == 3:
        if space_1 == 1:
            Draw_text(Space_1_x, Space_1_y, Space_1_width, Space_1_height, x_text)
        if space_2 == 1:
            Draw_text(Space_2_x, Space_2_y, Space_2_width, Space_2_height, x_text)
        if space_3 == 1:
            Draw_text(Space_3_x, Space_3_y, Space_3_width, Space_3_height, x_text)
        if space_4 == 1:
            Draw_text(Space_4_x, Space_4_y, Space_4_width, Space_4_height, x_text)
        if space_5 == 1:
            Draw_text(Space_5_x, Space_5_y, Space_5_width, Space_5_height, x_text)
        if space_6 == 1:
            Draw_text(Space_6_x, Space_6_y, Space_6_width, Space_6_height, x_text)
        if space_7 == 1:
            Draw_text(Space_7_x, Space_7_y, Space_7_width, Space_7_height, x_text)
        if space_8 == 1:
            Draw_text(Space_8_x, Space_8_y, Space_8_width, Space_8_height, x_text)
        if space_9 == 1:
            Draw_text(Space_9_x, Space_9_y, Space_9_width, Space_9_height, x_text)
        if space_1 == 2:
            Draw_text(Space_1_x, Space_1_y, Space_1_width, Space_1_height, o_text)
        if space_2 == 2:
            Draw_text(Space_2_x, Space_2_y, Space_2_width, Space_2_height, o_text)
        if space_3 == 2:
            Draw_text(Space_3_x, Space_3_y, Space_3_width, Space_3_height, o_text)
        if space_4 == 2:
            Draw_text(Space_4_x, Space_4_y, Space_4_width, Space_4_height, o_text)
        if space_5 == 2:
            Draw_text(Space_5_x, Space_5_y, Space_5_width, Space_5_height, o_text)
        if space_6 == 2:
            Draw_text(Space_6_x, Space_6_y, Space_6_width, Space_6_height, o_text)
        if space_7 == 2:
            Draw_text(Space_7_x, Space_7_y, Space_7_width, Space_7_height, o_text)
        if space_8 == 2:
            Draw_text(Space_8_x, Space_8_y, Space_8_width, Space_8_height, o_text)
        if space_9 == 2:
            Draw_text(Space_9_x, Space_9_y, Space_9_width, Space_9_height, o_text)

    pygame.display.update()

    Check_Game_End()

def playing_board():
    window.fill(white)
    if game_state == 1:
        window.fill(white)
        pygame.draw.rect(window, black, (Space_BG_x_GS1, Space_BG_y_GS1, Space_BG_width_GS1, Space_BG_height_GS1))
        pygame.draw.rect(window, white, (Space_1_x_GS1, Space_1_y_GS1, Space_1_width_GS1, Space_1_height_GS1))
        pygame.draw.rect(window, white, (Space_2_x_GS1, Space_2_y_GS1, Space_2_width_GS1, Space_2_height_GS1))
        pygame.draw.rect(window, white, (Space_3_x_GS1, Space_3_y_GS1, Space_3_width_GS1, Space_3_height_GS1))
        pygame.draw.rect(window, white, (Space_4_x_GS1, Space_4_y_GS1, Space_4_width_GS1, Space_4_height_GS1))
        pygame.draw.rect(window, white, (Space_5_x_GS1, Space_5_y_GS1, Space_5_width_GS1, Space_5_height_GS1))
        pygame.draw.rect(window, white, (Space_6_x_GS1, Space_6_y_GS1, Space_6_width_GS1, Space_6_height_GS1))
        pygame.draw.rect(window, white, (Space_7_x_GS1, Space_7_y_GS1, Space_7_width_GS1, Space_7_height_GS1))
        pygame.draw.rect(window, white, (Space_8_x_GS1, Space_8_y_GS1, Space_8_width_GS1, Space_8_height_GS1))
        pygame.draw.rect(window, white, (Space_9_x_GS1, Space_9_y_GS1, Space_9_width_GS1, Space_9_height_GS1))
        pygame.draw.rect(window, white, (Space_10_x_GS1, Space_10_y_GS1, Space_10_width_GS1, Space_10_height_GS1))
        pygame.draw.rect(window, white, (Space_11_x_GS1, Space_11_y_GS1, Space_11_width_GS1, Space_11_height_GS1))
        pygame.draw.rect(window, white, (Space_12_x_GS1, Space_12_y_GS1, Space_12_width_GS1, Space_12_height_GS1))
        pygame.draw.rect(window, white, (Space_13_x_GS1, Space_13_y_GS1, Space_13_width_GS1, Space_13_height_GS1))
        pygame.draw.rect(window, white, (Space_14_x_GS1, Space_14_y_GS1, Space_14_width_GS1, Space_14_height_GS1))
        pygame.draw.rect(window, white, (Space_15_x_GS1, Space_15_y_GS1, Space_15_width_GS1, Space_15_height_GS1))
        pygame.draw.rect(window, white, (Space_16_x_GS1, Space_16_y_GS1, Space_16_width_GS1, Space_16_height_GS1))
    elif game_state == 2 or game_state == 3:
        pygame.draw.rect(window, black, (Space_BG_x, Space_BG_y, Space_BG_width, Space_BG_height))
        pygame.draw.rect(window, white, (Space_1_x, Space_1_y, Space_1_width, Space_1_height))
        pygame.draw.rect(window, white, (Space_2_x, Space_2_y, Space_2_width, Space_2_height))
        pygame.draw.rect(window, white, (Space_3_x, Space_3_y, Space_3_width, Space_3_height))
        pygame.draw.rect(window, white, (Space_4_x, Space_4_y, Space_4_width, Space_4_height))
        pygame.draw.rect(window, white, (Space_5_x, Space_5_y, Space_5_width, Space_5_height))
        pygame.draw.rect(window, white, (Space_6_x, Space_6_y, Space_6_width, Space_6_height))
        pygame.draw.rect(window, white, (Space_7_x, Space_7_y, Space_7_width, Space_7_height))
        pygame.draw.rect(window, white, (Space_8_x, Space_8_y, Space_8_width, Space_8_height))
        pygame.draw.rect(window, white, (Space_9_x, Space_9_y, Space_9_width, Space_9_height))
    Handle_text()

def Check_Game_End():
    Close_Button()
    global space_1_GS1, space_2_GS1, space_3_GS1, space_4_GS1, space_5_GS1, space_6_GS1, space_7_GS1, space_8_GS1, space_9_GS1, space_10_GS1, space_11_GS1, space_12_GS1, space_13_GS1, space_14_GS1, space_15_GS1, space_16_GS1, space_1, space_2, space_3, space_4, space_5, space_6, space_7, space_8, space_9
    if game_state == 1:
        if space_1_GS1 == 1 and space_2_GS1 == 1 and space_3_GS1 == 1:
            Player_Won()
        if space_2_GS1 == 1 and space_3_GS1 == 1 and space_4_GS1 == 1:
            Player_Won()
        if space_5_GS1 == 1 and space_6_GS1 == 1 and space_7_GS1 == 1:
            Player_Won()
        if space_6_GS1 == 1 and space_7_GS1 == 1 and space_8_GS1 == 1:
            Player_Won()
        if space_9_GS1 == 1 and space_10_GS1 == 1 and space_11_GS1 == 1:
            Player_Won()
        if space_10_GS1 == 1 and space_11_GS1 == 1 and space_12_GS1 == 1:
            Player_Won()
        if space_13_GS1 == 1 and space_14_GS1 == 1 and space_15_GS1 == 1:
            Player_Won()
        if space_14_GS1 == 1 and space_15_GS1 == 1 and space_16_GS1 == 1:
            Player_Won()
        if space_1_GS1 == 1 and space_5_GS1 == 1 and space_9_GS1 == 1:
            Player_Won()
        if space_2_GS1 == 1 and space_6_GS1 == 1 and space_10_GS1 == 1:
            Player_Won()
        if space_3_GS1 == 1 and space_7_GS1 == 1 and space_11_GS1 == 1:
            Player_Won()
        if space_4_GS1 == 1 and space_8_GS1 == 1 and space_12_GS1 == 1:
            Player_Won()
        if space_5_GS1 == 1 and space_9_GS1 == 1 and space_13_GS1 == 1:
            Player_Won()
        if space_6_GS1 == 1 and space_10_GS1 == 1 and space_14_GS1 == 1:
            Player_Won()
        if space_7_GS1 == 1 and space_11_GS1 == 1 and space_15_GS1 == 1:
            Player_Won()
        if space_8_GS1 == 1 and space_12_GS1 == 1 and space_16_GS1 == 1:
            Player_Won()
        if space_1_GS1 == 1 and space_6_GS1 == 1 and space_11_GS1 == 1:
            Player_Won()
        if space_2_GS1 == 1 and space_7_GS1 == 1 and space_12_GS1 == 1:
            Player_Won()
        if space_5_GS1 == 1 and space_10_GS1 == 1 and space_15_GS1 == 1:
            Player_Won()
        if space_4_GS1 == 1 and space_7_GS1 == 1 and space_10_GS1 == 1:
            Player_Won()
        if space_3_GS1 == 1 and space_6_GS1 == 1 and space_9_GS1 == 1:
            Player_Won()
        if space_8_GS1 == 1 and space_11_GS1 == 1 and space_14_GS1 == 1:
            Player_Won()
        if space_9_GS1 == 1 and space_6_GS1 == 1 and space_3_GS1 == 1:
            Player_Won()
        if space_13_GS1 == 1 and space_10_GS1 == 1 and space_7_GS1 == 1:
            Player_Won()
        if space_14_GS1 == 1 and space_11_GS1 == 1 and space_8_GS1 == 1:
            Player_Won()
        if space_12_GS1 == 1 and space_7_GS1 == 1 and space_2_GS1 == 1:
            Player_Won()
        if space_16_GS1 == 1 and space_11_GS1 == 1 and space_6_GS1 == 1:
            Player_Won()
        if space_15_GS1 == 1 and space_10_GS1 == 1 and space_5_GS1 == 1:
            Player_Won()
        if space_1_GS1 == 2 and space_2_GS1 == 2 and space_3_GS1 == 2:
            opponent_O_wins()
        if space_2_GS1 == 2 and space_3_GS1 == 2 and space_4_GS1 == 2:
            opponent_O_wins()
        if space_5_GS1 == 2 and space_6_GS1 == 2 and space_7_GS1 == 2:
            opponent_O_wins()
        if space_6_GS1 == 2 and space_7_GS1 == 2 and space_8_GS1 == 2:
            opponent_O_wins()
        if space_9_GS1 == 2 and space_10_GS1 == 2 and space_11_GS1 == 2:
            opponent_O_wins()
        if space_10_GS1 == 2 and space_11_GS1 == 2 and space_12_GS1 == 2:
            opponent_O_wins()
        if space_13_GS1 == 2 and space_14_GS1 == 2 and space_15_GS1 == 2:
            opponent_O_wins()
        if space_14_GS1 == 2 and space_15_GS1 == 2 and space_16_GS1 == 2:
            opponent_O_wins()
        if space_1_GS1 == 2 and space_5_GS1 == 2 and space_9_GS1 == 2:
            opponent_O_wins()
        if space_2_GS1 == 2 and space_6_GS1 == 2 and space_10_GS1 == 2:
            opponent_O_wins()
        if space_3_GS1 == 2 and space_7_GS1 == 2 and space_11_GS1 == 2:
            opponent_O_wins()
        if space_4_GS1 == 2 and space_8_GS1 == 2 and space_12_GS1 == 2:
            opponent_O_wins()
        if space_5_GS1 == 2 and space_9_GS1 == 2 and space_13_GS1 == 2:
            opponent_O_wins()
        if space_6_GS1 == 2 and space_10_GS1 == 2 and space_14_GS1 == 2:
            opponent_O_wins()
        if space_7_GS1 == 2 and space_11_GS1 == 2 and space_15_GS1 == 2:
            opponent_O_wins()
        if space_8_GS1 == 2 and space_12_GS1 == 2 and space_16_GS1 == 2:
            opponent_O_wins()
        if space_1_GS1 == 2 and space_6_GS1 == 2 and space_11_GS1 == 2:
            opponent_O_wins()
        if space_2_GS1 == 2 and space_7_GS1 == 2 and space_12_GS1 == 2:
            opponent_O_wins()
        if space_5_GS1 == 2 and space_10_GS1 == 2 and space_15_GS1 == 2:
            opponent_O_wins()
        if space_4_GS1 == 2 and space_7_GS1 == 2 and space_10_GS1 == 2:
            opponent_O_wins()
        if space_3_GS1 == 2 and space_6_GS1 == 2 and space_9_GS1 == 2:
            opponent_O_wins()
        if space_8_GS1 == 2 and space_11_GS1 == 2 and space_14_GS1 == 2:
            opponent_O_wins()
        if space_9_GS1 == 2 and space_6_GS1 == 2 and space_3_GS1 == 2:
            opponent_O_wins()
        if space_13_GS1 == 2 and space_10_GS1 == 2 and space_7_GS1 == 2:
            opponent_O_wins()
        if space_14_GS1 == 2 and space_11_GS1 == 2 and space_8_GS1 == 2:
            opponent_O_wins()
        if space_12_GS1 == 2 and space_7_GS1 == 2 and space_2_GS1 == 2:
            opponent_O_wins()
        if space_16_GS1 == 2 and space_11_GS1 == 2 and space_6_GS1 == 2:
            opponent_O_wins()
        if space_15_GS1 == 2 and space_10_GS1 == 2 and space_5_GS1 == 2:
            opponent_O_wins()
        if space_1_GS1 == 3 and space_2_GS1 == 3 and space_3_GS1 == 3:
            opponent_A_wins()
        if space_2_GS1 == 3 and space_3_GS1 == 3 and space_4_GS1 == 3:
            opponent_A_wins()
        if space_5_GS1 == 3 and space_6_GS1 == 3 and space_7_GS1 == 3:
            opponent_A_wins()
        if space_6_GS1 == 3 and space_7_GS1 == 3 and space_8_GS1 == 3:
            opponent_A_wins()
        if space_9_GS1 == 3 and space_10_GS1 == 3 and space_11_GS1 == 3:
            opponent_A_wins()
        if space_10_GS1 == 3 and space_11_GS1 == 3 and space_12_GS1 == 3:
            opponent_A_wins()
        if space_13_GS1 == 3 and space_14_GS1 == 3 and space_15_GS1 == 3:
            opponent_A_wins()
        if space_14_GS1 == 3 and space_15_GS1 == 3 and space_16_GS1 == 3:
            opponent_A_wins()
        if space_1_GS1 == 3 and space_5_GS1 == 3 and space_9_GS1 == 3:
            opponent_A_wins()
        if space_2_GS1 == 3 and space_6_GS1 == 3 and space_10_GS1 == 3:
            opponent_A_wins()
        if space_3_GS1 == 3 and space_7_GS1 == 3 and space_11_GS1 == 3:
            opponent_A_wins()
        if space_4_GS1 == 3 and space_8_GS1 == 3 and space_12_GS1 == 3:
            opponent_A_wins()
        if space_5_GS1 == 3 and space_9_GS1 == 3 and space_13_GS1 == 3:
            opponent_A_wins()
        if space_6_GS1 == 3 and space_10_GS1 == 3 and space_14_GS1 == 3:
            opponent_A_wins()
        if space_7_GS1 == 3 and space_11_GS1 == 3 and space_15_GS1 == 3:
            opponent_A_wins()
        if space_8_GS1 == 3 and space_12_GS1 == 3 and space_16_GS1 == 3:
            opponent_A_wins()
        if space_1_GS1 == 3 and space_6_GS1 == 3 and space_11_GS1 == 3:
            opponent_A_wins()
        if space_2_GS1 == 3 and space_7_GS1 == 3 and space_12_GS1 == 3:
            opponent_A_wins()
        if space_5_GS1 == 3 and space_10_GS1 == 3 and space_15_GS1 == 3:
            opponent_A_wins()
        if space_4_GS1 == 3 and space_7_GS1 == 3 and space_10_GS1 == 3:
            opponent_A_wins()
        if space_3_GS1 == 3 and space_6_GS1 == 3 and space_9_GS1 == 3:
            opponent_A_wins()
        if space_8_GS1 == 3 and space_11_GS1 == 3 and space_14_GS1 == 3:
            opponent_A_wins()
        if space_9_GS1 == 3 and space_6_GS1 == 3 and space_3_GS1 == 3:
            opponent_A_wins()
        if space_13_GS1 == 3 and space_10_GS1 == 3 and space_7_GS1 == 3:
            opponent_A_wins()
        if space_14_GS1 == 3 and space_11_GS1 == 3 and space_8_GS1 == 3:
            opponent_A_wins()
        if space_12_GS1 == 3 and space_7_GS1 == 3 and space_2_GS1 == 3:
            opponent_A_wins()
        if space_16_GS1 == 3 and space_11_GS1 == 3 and space_6_GS1 == 3:
            opponent_A_wins()
        if space_15_GS1 == 3 and space_10_GS1 == 3 and space_5_GS1 == 3:
            opponent_A_wins()
        if space_1_GS1 > 0 and space_2_GS1 > 0 and space_3_GS1 > 0 and space_4_GS1 > 0 and space_5_GS1 > 0 and space_6_GS1 > 0 and space_7_GS1 > 0 and space_8_GS1 > 0 and space_9_GS1 > 0 and space_10_GS1 > 0 and space_11_GS1 > 0 and space_12_GS1 > 0 and space_13_GS1 > 0 and space_14_GS1 > 0 and space_15_GS1 > 0 and space_16_GS1 > 0:
            stalemate()
    elif game_state == 2 or game_state == 3:
        if space_1 == 1 and space_2 == 1 and space_3 == 1:
            Player_Won()
        if space_4 == 1 and space_5 == 1 and space_6 == 1:
            Player_Won()
        if space_7 == 1 and space_8 == 1 and space_9 == 1:
            Player_Won()
        if space_1 == 1 and space_4 == 1 and space_7 == 1:
            Player_Won()
        if space_2 == 1 and space_5 == 1 and space_8 == 1:
            Player_Won()
        if space_3 == 1 and space_6 == 1 and space_9 == 1:
            Player_Won()
        if space_1 == 1 and space_5 == 1 and space_9 == 1:
            Player_Won()
        if space_3 == 1 and space_5 == 1 and space_7 == 1:
            Player_Won()
        if space_1 == 2 and space_2 == 2 and space_3 == 2:
            Opponent_wins()
        if space_4 == 2 and space_5 == 2 and space_6 == 2:
            Opponent_wins()
        if space_7 == 2 and space_8 == 2 and space_9 == 2:
            Opponent_wins()
        if space_1 == 2 and space_4 == 2 and space_7 == 2:
            Opponent_wins()
        if space_2 == 2 and space_5 == 2 and space_8 == 2:
            Opponent_wins()
        if space_3 == 2 and space_6 == 2 and space_9 == 2:
            Opponent_wins()
        if space_1 == 2 and space_5 == 2 and space_9 == 2:
            Opponent_wins()
        if space_3 == 2 and space_5 == 2 and space_7 == 2:
            Opponent_wins()
        if space_1 > 0 and space_2 > 0 and space_3 > 0 and space_4 > 0 and space_5 > 0 and space_6 > 0 and space_7 > 0 and space_8 > 0 and space_9 > 0:
            stalemate()

game_over = False
game_state = 0
player_turn = 1

Main_menu()

while not game_over:
    Close_Button()
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            game_over = True
            pygame.quit()
            sys.exit()
        elif event.type == pygame.MOUSEBUTTONDOWN:
            mouse_x, mouse_y = pygame.mouse.get_pos()
            if game_state == 0:
                if play_x <= mouse_x <= play_x + play_width and play_y <= mouse_y <= play_y + play_height:
                    game_state = 2
                    playing_board()
                elif play_three_mode_x <= mouse_x <= play_three_mode_x + play_three_mode_width and play_three_mode_y <= mouse_y <= play_three_mode_y + play_three_mode_height:
                    game_state = 1
                    playing_board()
                elif play_local_mode_x <= mouse_x <= play_local_mode_x + play_local_mode_width and play_local_mode_y <= mouse_y <= play_local_mode_y + play_local_mode_height:
                    game_state = 3
                    playing_board()
                elif close_x <= mouse_x <= close_x + close_width and close_y <= mouse_y <= close_y + close_height:
                    game_state = None
                    game_over = True
                    pygame.quit()
                    sys.exit()
            elif game_state == 1:
                if close_x <= mouse_x <= close_x + close_width and close_y <= mouse_y <= close_y + close_height:
                    opponent_turn = False
                    game_state = 0
                    space_1_GS1 = 0
                    space_2_GS1 = 0
                    space_3_GS1 = 0
                    space_4_GS1 = 0
                    space_5_GS1 = 0
                    space_6_GS1 = 0
                    space_7_GS1 = 0
                    space_8_GS1 = 0
                    space_9_GS1 = 0
                    space_10_GS1 = 0
                    space_11_GS1 = 0
                    space_12_GS1 = 0
                    space_13_GS1 = 0
                    space_14_GS1 = 0
                    space_15_GS1 = 0
                    space_16_GS1 = 0
                    Available_list_GS1 = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9", "space_10", "space_11", "space_12", "space_13", "space_14", "space_15", "space_16"]
                    Main_menu()
                if Space_1_x_GS1 <= mouse_x <= Space_1_x_GS1 + Space_1_width_GS1 and Space_1_y_GS1 <= mouse_y <= Space_1_y_GS1 + Space_1_height_GS1:
                    if "space_1" in Available_list_GS1:
                        Available_list_GS1.remove("space_1")
                        space_1_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_2_x_GS1 <= mouse_x <= Space_2_x_GS1 + Space_2_width_GS1 and Space_2_y_GS1 <= mouse_y <= Space_2_y_GS1 + Space_2_height_GS1:
                    if "space_2" in Available_list_GS1:
                        Available_list_GS1.remove("space_2")
                        space_2_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_3_x_GS1 <= mouse_x <= Space_3_x_GS1 + Space_3_width_GS1 and Space_3_y_GS1 <= mouse_y <= Space_3_y_GS1 + Space_3_height_GS1:
                    if "space_3" in Available_list_GS1:
                        Available_list_GS1.remove("space_3")
                        space_3_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_4_x_GS1 <= mouse_x <= Space_4_x_GS1 + Space_4_width_GS1 and Space_4_y_GS1 <= mouse_y <= Space_4_y_GS1 + Space_4_height_GS1:
                    if "space_4" in Available_list_GS1:
                        Available_list_GS1.remove("space_4")
                        space_4_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_5_x_GS1 <= mouse_x <= Space_5_x_GS1 + Space_5_width_GS1 and Space_5_y_GS1 <= mouse_y <= Space_5_y_GS1 + Space_5_height_GS1:
                    if "space_5" in Available_list_GS1:
                        Available_list_GS1.remove("space_5")
                        space_5_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_6_x_GS1 <= mouse_x <= Space_6_x_GS1 + Space_6_width_GS1 and Space_6_y_GS1 <= mouse_y <= Space_6_y_GS1 + Space_6_height_GS1:
                    if "space_6" in Available_list_GS1:
                        Available_list_GS1.remove("space_6")
                        space_6_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_7_x_GS1 <= mouse_x <= Space_7_x_GS1 + Space_7_width_GS1 and Space_7_y_GS1 <= mouse_y <= Space_7_y_GS1 + Space_7_height_GS1:
                    if "space_7" in Available_list_GS1:
                        Available_list_GS1.remove("space_7")
                        space_7_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_8_x_GS1 <= mouse_x <= Space_8_x_GS1 + Space_8_width_GS1 and Space_8_y_GS1 <= mouse_y <= Space_8_y_GS1 + Space_8_height_GS1:
                    if "space_8" in Available_list_GS1:
                        Available_list_GS1.remove("space_8")
                        space_8_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_9_x_GS1 <= mouse_x <= Space_9_x_GS1 + Space_9_width_GS1 and Space_9_y_GS1 <= mouse_y <= Space_9_y_GS1 + Space_9_height_GS1:
                    if "space_9" in Available_list_GS1:
                        Available_list_GS1.remove("space_9")
                        space_9_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_10_x_GS1 <= mouse_x <= Space_10_x_GS1 + Space_10_width_GS1 and Space_10_y_GS1 <= mouse_y <= Space_10_y_GS1 + Space_10_height_GS1:
                    if "space_10" in Available_list_GS1:
                        Available_list_GS1.remove("space_10")
                        space_10_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_11_x_GS1 <= mouse_x <= Space_11_x_GS1 + Space_11_width_GS1 and Space_11_y_GS1 <= mouse_y <= Space_11_y_GS1 + Space_11_height_GS1:
                    if "space_11" in Available_list_GS1:
                        Available_list_GS1.remove("space_11")
                        space_11_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_12_x_GS1 <= mouse_x <= Space_12_x_GS1 + Space_12_width_GS1 and Space_12_y_GS1 <= mouse_y <= Space_12_y_GS1 + Space_12_height_GS1:
                    if "space_12" in Available_list_GS1:
                        Available_list_GS1.remove("space_12")
                        space_12_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_13_x_GS1 <= mouse_x <= Space_13_x_GS1 + Space_13_width_GS1 and Space_13_y_GS1 <= mouse_y <= Space_13_y_GS1 + Space_13_height_GS1:
                    if "space_13" in Available_list_GS1:
                        Available_list_GS1.remove("space_13")
                        space_13_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_14_x_GS1 <= mouse_x <= Space_14_x_GS1 + Space_14_width_GS1 and Space_14_y_GS1 <= mouse_y <= Space_14_y_GS1 + Space_14_height_GS1:
                    if "space_14" in Available_list_GS1:
                        Available_list_GS1.remove("space_14")
                        space_14_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_15_x_GS1 <= mouse_x <= Space_15_x_GS1 + Space_15_width_GS1 and Space_15_y_GS1 <= mouse_y <= Space_15_y_GS1 + Space_15_height_GS1:
                    if "space_15" in Available_list_GS1:
                        Available_list_GS1.remove("space_15")
                        space_15_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
                if Space_16_x_GS1 <= mouse_x <= Space_16_x_GS1 + Space_16_width_GS1 and Space_16_y_GS1 <= mouse_y <= Space_16_y_GS1 + Space_16_height_GS1:
                    if "space_16" in Available_list_GS1:
                        Available_list_GS1.remove("space_16")
                        space_16_GS1 = 1
                        opponent_turn = True
                        playing_board()
                        opponent_O_moves()
            elif game_state == 2:
                if close_x <= mouse_x <= close_x + close_width and close_y <= mouse_y <= close_y + close_height:
                    opponent_turn = False
                    game_state = 0
                    space_1 = 0
                    space_2 = 0
                    space_3 = 0
                    space_4 = 0
                    space_5 = 0
                    space_6 = 0
                    space_7 = 0
                    space_8 = 0
                    space_9 = 0
                    Available_list = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9"]
                    Main_menu()
                if Space_1_x <= mouse_x <= Space_1_x + Space_1_width and Space_1_y <= mouse_y <= Space_1_y + Space_1_height:
                    if "space_1" in Available_list:
                        Available_list.remove("space_1")
                        space_1 = 1
                        opponent_turn = True
                        playing_board()
                if Space_2_x <= mouse_x <= Space_2_x + Space_2_width and Space_2_y <= mouse_y <= Space_2_y + Space_2_height:
                    if "space_2" in Available_list:
                        Available_list.remove("space_2")
                        space_2 = 1
                        opponent_turn = True
                        playing_board()
                if Space_3_x <= mouse_x <= Space_3_x + Space_3_width and Space_3_y <= mouse_y <= Space_3_y + Space_3_height:
                    if "space_3" in Available_list:
                        Available_list.remove("space_3")
                        space_3 = 1
                        opponent_turn = True
                        playing_board()
                if Space_4_x <= mouse_x <= Space_4_x + Space_4_width and Space_4_y <= mouse_y <= Space_4_y + Space_4_height:
                    if "space_4" in Available_list:
                        Available_list.remove("space_4")
                        space_4 = 1
                        opponent_turn = True
                        playing_board()
                if Space_5_x <= mouse_x <= Space_5_x + Space_5_width and Space_5_y <= mouse_y <= Space_5_y + Space_5_height:
                    if "space_5" in Available_list:
                        Available_list.remove("space_5")
                        space_5 = 1
                        opponent_turn = True
                        playing_board()
                if Space_6_x <= mouse_x <= Space_6_x + Space_6_width and Space_6_y <= mouse_y <= Space_6_y + Space_6_height:
                    if "space_6" in Available_list:
                        Available_list.remove("space_6")
                        space_6 = 1
                        opponent_turn = True
                        playing_board()
                if Space_7_x <= mouse_x <= Space_7_x + Space_7_width and Space_7_y <= mouse_y <= Space_7_y + Space_7_height:
                    if "space_7" in Available_list:
                        Available_list.remove("space_7")
                        space_7 = 1
                        opponent_turn = True
                        playing_board()
                if Space_8_x <= mouse_x <= Space_8_x + Space_8_width and Space_8_y <= mouse_y <= Space_8_y + Space_8_height:
                    if "space_8" in Available_list:
                        Available_list.remove("space_8")
                        space_8 = 1
                        opponent_turn = True
                        playing_board()
                if Space_9_x <= mouse_x <= Space_9_x + Space_9_width and Space_9_y <= mouse_y <= Space_9_y + Space_9_height:
                    if "space_9" in Available_list:
                        Available_list.remove("space_9")
                        space_9 = 1
                        opponent_turn = True
                        playing_board()
                Opponent_move()
            elif game_state == 3:
                if close_x <= mouse_x <= close_x + close_width and close_y <= mouse_y <= close_y + close_height:
                    game_state = 0
                    space_1 = 0
                    space_2 = 0
                    space_3 = 0
                    space_4 = 0
                    space_5 = 0
                    space_6 = 0
                    space_7 = 0
                    space_8 = 0
                    space_9 = 0
                    Available_list = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9"]
                    Main_menu()
                elif player_turn == 1:
                    if Space_1_x <= mouse_x <= Space_1_x + Space_1_width and Space_1_y <= mouse_y <= Space_1_y + Space_1_height:
                        if "space_1" in Available_list:
                            Available_list.remove("space_1")
                            space_1 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_2_x <= mouse_x <= Space_2_x + Space_2_width and Space_2_y <= mouse_y <= Space_2_y + Space_2_height:
                        if "space_2" in Available_list:
                            Available_list.remove("space_2")
                            space_2 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_3_x <= mouse_x <= Space_3_x + Space_3_width and Space_3_y <= mouse_y <= Space_3_y + Space_3_height:
                        if "space_3" in Available_list:
                            Available_list.remove("space_3")
                            space_3 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_4_x <= mouse_x <= Space_4_x + Space_4_width and Space_4_y <= mouse_y <= Space_4_y + Space_4_height:
                        if "space_4" in Available_list:
                            Available_list.remove("space_4")
                            space_4 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_5_x <= mouse_x <= Space_5_x + Space_5_width and Space_5_y <= mouse_y <= Space_5_y + Space_5_height:
                        if "space_5" in Available_list:
                            Available_list.remove("space_5")
                            space_5 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_6_x <= mouse_x <= Space_6_x + Space_6_width and Space_6_y <= mouse_y <= Space_6_y + Space_6_height:
                        if "space_6" in Available_list:
                            Available_list.remove("space_6")
                            space_6 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_7_x <= mouse_x <= Space_7_x + Space_7_width and Space_7_y <= mouse_y <= Space_7_y + Space_7_height:
                        if "space_7" in Available_list:
                            Available_list.remove("space_7")
                            space_7 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_8_x <= mouse_x <= Space_8_x + Space_8_width and Space_8_y <= mouse_y <= Space_8_y + Space_8_height:
                        if "space_8" in Available_list:
                            Available_list.remove("space_8")
                            space_8 = 1
                            player_turn = player_turn + 1
                            playing_board()
                    if Space_9_x <= mouse_x <= Space_9_x + Space_9_width and Space_9_y <= mouse_y <= Space_9_y + Space_9_height:
                        if "space_9" in Available_list:
                            Available_list.remove("space_9")
                            space_9 = 1
                            player_turn = player_turn + 1
                            playing_board()
                elif player_turn == 2:
                    if Space_1_x <= mouse_x <= Space_1_x + Space_1_width and Space_1_y <= mouse_y <= Space_1_y + Space_1_height: 
                        if "space_1" in Available_list:
                            Available_list.remove("space_1")
                            space_1 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_2_x <= mouse_x <= Space_2_x + Space_2_width and Space_2_y <= mouse_y <= Space_2_y + Space_2_height:
                        if "space_2" in Available_list:
                            Available_list.remove("space_2")
                            space_2 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_3_x <= mouse_x <= Space_3_x + Space_3_width and Space_3_y <= mouse_y <= Space_3_y + Space_3_height:
                        if "space_3" in Available_list:
                            Available_list.remove("space_3")
                            space_3 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_4_x <= mouse_x <= Space_4_x + Space_4_width and Space_4_y <= mouse_y <= Space_4_y + Space_4_height:
                        if "space_4" in Available_list:
                            Available_list.remove("space_4")
                            space_4 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_5_x <= mouse_x <= Space_5_x + Space_5_width and Space_5_y <= mouse_y <= Space_5_y + Space_5_height:
                        if "space_5" in Available_list:
                            Available_list.remove("space_5")
                            space_5 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_6_x <= mouse_x <= Space_6_x + Space_6_width and Space_6_y <= mouse_y <= Space_6_y + Space_6_height:
                        if "space_6" in Available_list:
                            Available_list.remove("space_6")
                            space_6 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_7_x <= mouse_x <= Space_7_x + Space_7_width and Space_7_y <= mouse_y <= Space_7_y + Space_7_height:
                        if "space_7" in Available_list:
                            Available_list.remove("space_7")
                            space_7 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_8_x <= mouse_x <= Space_8_x + Space_8_width and Space_8_y <= mouse_y <= Space_8_y + Space_8_height:
                        if "space_8" in Available_list:
                            Available_list.remove("space_8")
                            space_8 = 2
                            player_turn = player_turn - 1
                            playing_board()
                    if Space_9_x <= mouse_x <= Space_9_x + Space_9_width and Space_9_y <= mouse_y <= Space_9_y + Space_9_height:
                        if "space_9" in Available_list:
                            player_turn = player_turn - 1
                            Available_list.remove("space_9")
                            space_9 = 2
                            playing_board()
        elif event.type == pygame.KEYDOWN:
            key_pressed = pygame.key.get_pressed()
            if game_state == 0:
                if key_pressed[pygame.K_ESCAPE]:
                    game_state = None
                    game_over = True
                    pygame.quit()
                    sys.exit()
                elif key_pressed[pygame.K_1]:
                    game_state = 1
                    playing_board()
                elif key_pressed[pygame.K_2]:
                    game_state = 2
                    playing_board()
                elif key_pressed[pygame.K_3]:
                    game_state = 3
                    playing_board()
            if game_state == 1:
                if key_pressed[pygame.K_ESCAPE]:
                    game_state = 0
                    space_1 = 0
                    space_2 = 0
                    space_3 = 0
                    space_4 = 0
                    space_5 = 0
                    space_6 = 0
                    space_7 = 0
                    space_8 = 0
                    space_9 = 0
                    space_10_GS1 = 0
                    space_11_GS1 = 0
                    space_12_GS1 = 0
                    space_13_GS1 = 0
                    space_14_GS1 = 0
                    space_15_GS1 = 0
                    space_16_GS1 = 0
                    Available_list_GS1 = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9", "space_10", "space_11", "space_12", "space_13", "space_14", "space_15", "space_16"]
                    Main_menu()
            if game_state == 2:
                if key_pressed[pygame.K_ESCAPE]:
                    opponent_turn = False
                    game_state = 0
                    space_1 = 0
                    space_2 = 0
                    space_3 = 0
                    space_4 = 0
                    space_5 = 0
                    space_6 = 0
                    space_7 = 0
                    space_8 = 0
                    space_9 = 0
                    Available_list = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9"]
                    Main_menu()
                if key_pressed[pygame.K_LSHIFT] or key_pressed[pygame.K_RSHIFT]:
                    if key_pressed[pygame.K_1]:
                        if "space_1" in Available_list:
                            Available_list.remove("space_1")
                            space_1 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_2]:
                        if "space_2" in Available_list:
                            Available_list.remove("space_2")
                            space_2 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_3]:
                        if "space_3" in Available_list:
                            Available_list.remove("space_3")
                            space_3 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_4]:
                        if "space_4" in Available_list:
                            Available_list.remove("space_4")
                            space_4 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_5]:
                        if "space_5" in Available_list:
                            Available_list.remove("space_5")
                            space_5 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_6]:
                        if "space_6" in Available_list:
                            Available_list.remove("space_6")
                            space_6 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_7]:
                        if "space_7" in Available_list:
                            Available_list.remove("space_7")
                            space_7 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_8]:
                        if "space_8" in Available_list:
                            Available_list.remove("space_8")
                            space_8 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
                    if key_pressed[pygame.K_9]:
                        if "space_9" in Available_list:
                            Available_list.remove("space_9")
                            space_9 = 1
                            opponent_turn = True
                            playing_board()
                            Opponent_move()
            if game_state == 3:
                if key_pressed[pygame.K_ESCAPE]:
                    game_state = 0
                    space_1 = 0
                    space_2 = 0
                    space_3 = 0
                    space_4 = 0
                    space_5 = 0
                    space_6 = 0
                    space_7 = 0
                    space_8 = 0
                    space_9 = 0
                    Available_list = ["space_1", "space_2", "space_3", "space_4", "space_5", "space_6", "space_7", "space_8", "space_9"]
                    Main_menu()
                if player_turn == 1:
                    if key_pressed[pygame.K_LSHIFT] or key_pressed[pygame.K_RSHIFT]:
                        if key_pressed[pygame.K_1]:
                            if "space_1" in Available_list:
                                Available_list.remove("space_1")
                                space_1 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_2]:
                            if "space_2" in Available_list:
                                Available_list.remove("space_2")
                                space_2 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_3]:
                            if "space_3" in Available_list:
                                Available_list.remove("space_3")
                                space_3 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_4]:
                            if "space_4" in Available_list:
                                Available_list.remove("space_4")
                                space_4 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_5]:
                            if "space_5" in Available_list:
                                Available_list.remove("space_5")
                                space_5 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_6]:
                            if "space_6" in Available_list:
                                Available_list.remove("space_6")
                                space_6 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_7]:
                            if "space_7" in Available_list:
                                Available_list.remove("space_7")
                                space_7 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_8]:
                            if "space_8" in Available_list:
                                Available_list.remove("space_8")
                                space_8 = 1
                                player_turn = player_turn + 1
                                playing_board()
                        if key_pressed[pygame.K_9]:
                            if "space_9" in Available_list:
                                Available_list.remove("space_9")
                                space_9 = 1
                                player_turn = player_turn + 1
                                playing_board()
                elif player_turn == 2:
                    if key_pressed[pygame.K_LSHIFT] or key_pressed[pygame.K_RSHIFT]:
                        if key_pressed[pygame.K_1]:
                            if "space_1" in Available_list:
                                Available_list.remove("space_1")
                                space_1 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_2]:
                            if "space_2" in Available_list:
                                Available_list.remove("space_2")
                                space_2 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_3]:
                            if "space_3" in Available_list:
                                Available_list.remove("space_3")
                                space_3 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_4]:
                            if "space_4" in Available_list:
                                Available_list.remove("space_4")
                                space_4 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_5]:
                            if "space_5" in Available_list:
                                Available_list.remove("space_5")
                                space_5 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_6]:
                            if "space_6" in Available_list:
                                Available_list.remove("space_6")
                                space_6 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_7]:
                            if "space_7" in Available_list:
                                Available_list.remove("space_7")
                                space_7 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_8]:
                            if "space_8" in Available_list:
                                Available_list.remove("space_8")
                                space_8 = 2
                                player_turn = player_turn - 1
                                playing_board()
                        if key_pressed[pygame.K_9]:
                            if "space_9" in Available_list:
                                player_turn = player_turn - 1
                                Available_list.remove("space_9")
                                space_9 = 2
                                playing_board()

    pygame.display.flip()

pygame.quit()
sys.exit()